/* generates a grid for given spherical harmonic coefficients 
   grid output to file  
*/

#include <stdio.h>
#include <math.h>
#include "LIB/glob.h"
#include "LIB/constmap.h"

float **farray2();
float *assolegendre();
void free_farray2();

FILE *gridf;

void harmogrid(maxs,coef,conven,ifset)
int maxs;
float *coef;   /* spherical harmonic coefficients: a, b
		* f=sum (a*cos(m*phi)+b*sin(m*phi))*P(theta)
                */
char *conven; /*convention of spherical harmonic: P, p, X, X^, P^*/
/* For s3d files, convention must be X^ */
char ifset;   /*'y': set smin,smax,aeo*/
{
float **grid,**cossintphi,**p,*y,fac;
static int smin,smax;
static char aeo;
float theta,phi,sum;
int s,t,index,i,j,k,imax;
float cosphi,sinphi,costph,sintph,temp;

        if(ifset=='y')
        { printf("\nMax degree of model is %d",maxs);
	  do
	  { printf("\nsmin & smax of grid :");
	    scanf("%d %d%*c",&smin,&smax);
	  } while(smax>maxs);
	
	  do
	  { printf("\nType 'a' to grid  all degrees");
	    printf("\n     'e' to grid even degrees only");
	    printf("\n or  'o' to grid  odd degrees only  :");
	    scanf("%c",&aeo);
	  } while(aeo!='a' && aeo!='e' && aeo!='o');
	}
        maxs=smax;
        
        imax=(maxs+1)*(maxs+1);
	
	for(index=0,s=0;s<smin;s++)
	for(t=0;t<2*s+1;t++)
	  coef[index++]=0.0;
	
	if(aeo!='a')
	for(s=smin;s<=smax;s++)
	{ fac=1.;
	  if( (s%2 && aeo=='e') || (!(s%2) && aeo=='o') ) fac=0.;
	  for(t=0;t<2*s+1;t++)
	    coef[index++]*=fac;
	}

	p=farray2(0,Row-1,0,imax-1);
	for(i=0;i<Row;i++)
	{ theta=CONV*Dy*(float)i;
	  if(theta<0.0) theta=0.0;
	  if(theta>PI) theta=PI;
	  for(index=-1,s=0;s<=maxs;s++)
	  { y=assolegendre(theta,s,conven);
	    for(t=0;t<=s;t++)
	    { p[i][++index]=y[t];
	      if(t) p[i][++index]=y[t];
	    }
	  }
	}
	
	cossintphi=farray2(0,Col-1,0,imax-1);
	for(j=0;j<Col;j++)
	{ phi=CONV*((float)j*Dx);
	  cosphi=(float)cos((double)phi);
	  sinphi=(float)sin((double)phi);
	  for(index=-1,s=0;s<=maxs;s++)
	  for(costph=1.0,sintph=0.0,t=0;t<=s;t++)
	  { cossintphi[j][++index]=costph;
	    if(t) cossintphi[j][++index]=sintph;
	    temp=costph*cosphi-sintph*sinphi;
	    sintph=sintph*cosphi+costph*sinphi;
	    costph=temp;
	  }
	}
	
	grid=farray2(0,Row-1,0,Col-1);
	for(i=0;i<Row;i++)
	for(j=0;j<Col;j++)
	{ for(sum=0.0,k=0;k<imax;k++)
	    sum+=coef[k]*cossintphi[j][k]*p[i][k];
	  grid[i][j]=sum;
	}
	
	  gridf=fopen("grid.dat","w");
	  for(i=0;i<Row;i++) {
            theta=Dy*(float)i;
	    for(j=0;j<Col;j++) {
	      phi=((float)j*Dx);
	      if(phi!=360.)
	        fprintf(gridf,"%.6f\t%.6f\t%.6f\n",theta,phi,grid[i][j]);
	    }
	  }
	  fclose(gridf);
	    
	free_farray2(p,0,Row-1,0);
	free_farray2(cossintphi,0,Col-1,0);
		
	free_farray2(grid,0,Row-1,0);
}
